/***********************************************************************
*                             "crossover.h"	   						   *
*			Implementacion de distintos metodos de crossover		   *
***********************************************************************/


/* 1 = Crossover de 1 punto elegido aleatoriamente entre 1 y largo-1 */
void crossoverUnPunto(cromosoma a, cromosoma b, cromosoma *c, cromosoma *d, float pbb);

/* 2 = Crossover de 2 puntos elegidos aleatoriamente entre 1 y largo-1 */
void crossoverDosPuntos(cromosoma a, cromosoma b, cromosoma *c, cromosoma *d, float pbb);

/* 3 = Crossover Uniforme (pbb de cruce bit a bit igual a 0.5) */
void crossoverUniforme(cromosoma a, cromosoma b, cromosoma *c, cromosoma *d, float pbb);

/* 4 = Crossover Binomial (pbb de cruce bit a bit aleatoria) */
void crossoverBinomial(cromosoma a, cromosoma b, cromosoma *c, cromosoma *d, float pbb);

/* Cruza los individuos de la poblacion usando el metodo de crossover elegido */
void crossoverPoblacion(poblacion p, poblacion *q, void (*func_crossover)
					   (cromosoma a, cromosoma b, cromosoma *c, cromosoma *d, float pbb), 
					   float pbb_crossover);
